//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.WorktableIntegration.WorktableService
{
    
    
    /// <summary>
    /// Class that implements the IWorktableService interface through SiLA2
    /// </summary>
    public partial class WorktableServiceClient : IWorktableService
    {
        
        private System.Lazy<BoundingBox> _boundingBox;
        
        private System.Lazy<System.Collections.Generic.ICollection<SiteTemplate>> _siteTemplates;
        
        private System.Lazy<System.Collections.Generic.ICollection<Site>> _sites;
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.tecan.sila.worktableintegration.infrastructure.worktableservice.v1.Worktabl" +
            "eService";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public WorktableServiceClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
            InitLazyRequests();
        }
        
        /// <summary>
        /// The outer hull of the device
        /// </summary>
        public virtual BoundingBox BoundingBox
        {
            get
            {
                return _boundingBox.Value;
            }
        }
        
        /// <summary>
        /// The templates for sites used by this device
        /// </summary>
        public virtual System.Collections.Generic.ICollection<SiteTemplate> SiteTemplates
        {
            get
            {
                return _siteTemplates.Value;
            }
        }
        
        /// <summary>
        /// The sites that this device offers
        /// </summary>
        public virtual System.Collections.Generic.ICollection<Site> Sites
        {
            get
            {
                return _sites.Value;
            }
        }
        
        private BoundingBox RequestBoundingBox()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("tecan.sila.worktableintegration/infrastructure/WorktableService/v1/Property/Bound" +
                    "ingBox");
            try
            {
                BoundingBox response = _channel.ReadProperty<PropertyResponse<BoundingBoxDto>>(_serviceName, "BoundingBox", "tecan.sila.worktableintegration/infrastructure/WorktableService/v1/Property/Bound" +
                        "ingBox", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private System.Collections.Generic.ICollection<SiteTemplate> RequestSiteTemplates()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("tecan.sila.worktableintegration/infrastructure/WorktableService/v1/Property/SiteT" +
                    "emplates");
            try
            {
                System.Collections.Generic.ICollection<SiteTemplate> response = _channel.ReadProperty<PropertyResponse<System.Collections.Generic.List<SiteTemplateDto>>>(_serviceName, "SiteTemplates", "tecan.sila.worktableintegration/infrastructure/WorktableService/v1/Property/SiteT" +
                        "emplates", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private System.Collections.Generic.ICollection<Site> RequestSites()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("tecan.sila.worktableintegration/infrastructure/WorktableService/v1/Property/Sites" +
                    "");
            try
            {
                System.Collections.Generic.ICollection<Site> response = _channel.ReadProperty<PropertyResponse<System.Collections.Generic.List<SiteDto>>>(_serviceName, "Sites", "tecan.sila.worktableintegration/infrastructure/WorktableService/v1/Property/Sites" +
                        "", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Initializes lazies for non-observable properties.
        /// </summary>
        private void InitLazyRequests()
        {
            _boundingBox = new System.Lazy<BoundingBox>(RequestBoundingBox);
            _siteTemplates = new System.Lazy<System.Collections.Generic.ICollection<SiteTemplate>>(RequestSiteTemplates);
            _sites = new System.Lazy<System.Collections.Generic.ICollection<Site>>(RequestSites);
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Worktable Service.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class WorktableServiceClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "tecan.sila.worktableintegration/infrastructure/WorktableService/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IWorktableService);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new WorktableServiceClient(channel, executionManager);
        }
    }
}

